; by kero

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32

.data
panelka		db "Panelka",0
caption		db "Overlapped  after  SetParent :  right click  (caption  on/off) ,  left double-click  (create) ,  dragging .",0
limit			db "Limit of nesting :  "
frmt			db "%lu",0
frmt2			db "%lu  /  %lu",0

.data?
hinst			HINSTANCE ?
hwnd			HWND ?
count			dd ?

.code

;#################################################################################################

CaptionTrigger proc hWnd:HWND
	invoke GetWindowLong,hWnd,GWL_STYLE
	mov ecx,eax
	mov edx,WS_CAPTION
	and ecx,edx
	.if ecx==edx
		not edx
		and eax,edx
	.else
		or eax,edx
	.endif
	invoke SetWindowLong,hWnd,GWL_STYLE,eax
	invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
	ret
CaptionTrigger endp

;#################################################################################################

NextNest proc uses ebx edi esi hWnd:HWND
	local rt:RECT
	local buf[128]:BYTE
@@:
	invoke GetWindowLong,hWnd,GWL_USERDATA
	mov edi,eax
	and eax,1
	.if eax!=0
		shr edi,1
		invoke wsprintf,addr buf,offset limit,edi
		invoke MessageBox,hWnd,addr buf,offset panelka,40000h
		xor eax,eax
		ret
	.endif
	invoke GetClientRect,hWnd,addr rt
	invoke CreateWindowEx,WS_EX_TOOLWINDOW,offset panelka,0,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN OR WS_VISIBLE,0,0,rt.right,rt.bottom,0,0,hinst,0
	mov ebx,eax
	invoke CaptionTrigger,ebx
	invoke SetParent,ebx,hWnd
	mov esi,eax
	.if eax==0
		inc edi
		invoke SetWindowLong,hWnd,GWL_USERDATA,edi
		xor edi,edi
	.else
		shr edi,1
		inc edi
	.endif
	invoke wsprintf,addr buf,offset frmt2,edi,count
	invoke SendMessage,ebx,WM_SETTEXT,0,addr buf
	shl edi,1
	invoke SetWindowLong,ebx,GWL_USERDATA,edi
	.if esi==0
		invoke CaptionTrigger,hWnd
		invoke DestroyWindow,ebx
		jmp @b
	.endif
	mov eax,ebx
	ret
NextNest endp

;#################################################################################################

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_DESTROY
		mov eax,hWnd
		.if eax==hwnd
			invoke PostQuitMessage,0
		.endif

	.elseif uMsg==WM_CREATE
		inc count

	.elseif uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_RBUTTONDOWN
		invoke CaptionTrigger,hWnd

	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke NextNest,hWnd

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

;#################################################################################################

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local msg:MSG

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_DBLCLKS
	mov wc.lpfnWndProc, offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground,COLOR_WINDOW
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset panelka
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx,WS_EX_TOOLWINDOW,offset panelka,offset caption,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN OR WS_VISIBLE,100,100,650,500,0,0,hInst,0
	mov hwnd,eax
	.while TRUE
		invoke NextNest,eax
		.break .if (!eax)
	.endw
;	invoke UpdateWindow,hwnd

	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

;#################################################################################################

start:
	dec count
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start

;#################################################################################################
