; by kero

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

NewProc proto :DWORD,:DWORD,:DWORD,:DWORD

include windows.inc
inclib  user32
inclib  kernel32
inclib  shlwapi

.data
DlgName	db "Dlg",0
class		db "static",0
caption	db "Child",0
message	db "Limit of nesting :  "
frmt		db "%lu",0

.data?
hinst		HINSTANCE ?
count		dd ?

.code

;#######################################################################################################

NextNest proc uses ebx edi hWnd:HWND
	local rt:RECT
	local buf[128]:BYTE

	inc count
	invoke SendMessage,hWnd,WM_GETTEXT,127,addr buf
	invoke StrToInt,addr buf
	inc eax
	mov edi,eax
	invoke GetClientRect,hWnd,addr rt
	invoke CreateWindowEx,0,\
												offset class,0,\
												WS_CHILD OR WS_VISIBLE OR WS_CLIPCHILDREN OR WS_CLIPSIBLINGS OR WS_DLGFRAME OR SS_NOTIFY,\
												0,0,rt.right,rt.bottom,\
												hWnd,count,hinst,0
	mov ebx,eax
	.if eax==0
		dec count
		dec edi
		invoke wsprintf,addr buf,offset message,edi
		invoke MessageBox,hWnd,addr buf,offset caption,40000h
		xor eax,eax
		ret
	.endif
	invoke SetWindowLong,ebx,GWL_WNDPROC,addr NewProc
	invoke SetWindowLong,ebx,GWL_USERDATA,eax
	invoke wsprintf,addr buf,offset frmt,edi
	invoke SendMessage,ebx,WM_SETTEXT,0,addr buf
	mov eax,ebx
	ret
NextNest endp

;#######################################################################################################

NewProc proc hWnd:HWND,uMsg:DWORD,wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_RBUTTONDOWN
		invoke DestroyWindow,hWnd

	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke NextNest,hWnd

	.endif
	invoke GetWindowLong,hWnd,GWL_USERDATA
	invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	ret
NewProc endp

;#######################################################################################################

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if	uMsg==WM_CLOSE
		invoke EndDialog,hWnd,0

	.elseif uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_INITDIALOG
		invoke ShowWindow,hWnd,SW_SHOWNORMAL
		mov eax,hWnd
		.while TRUE
			invoke NextNest,eax
			.break .if (!eax)
		.endw

	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke NextNest,hWnd

	.else
		xor eax,eax
		ret
	.endif
	xor eax,eax
	inc eax
	ret
DlgProc endp

;#######################################################################################################

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke DialogBoxParam,eax,offset DlgName,0,offset DlgProc,0
	invoke ExitProcess,eax
end start

;#######################################################################################################
